﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Bus
{
    internal class DrawingObjectBus : IDrawingObject
    {
        private DrawingBus _bus = null;
        public float Step => _bus?.Bus?.Step ?? 0;

        public DrawingObjectBus(DrawingBus bus)
        {
            _bus = bus;
        }

        public (float Left, float Right, float Top, float Bottom) GetCurrentPosition()
        {
            return _bus?.GetCurrentPosition() ?? default;
        }

        public void MoveObject(Direction direction)
        {
            _bus?.MoveTransport(direction);
        }

        public void SetObject(int x, int y, int width, int height)
        {
            _bus.SetPosition(x, y, width, height);
        }

        void IDrawingObject.DrawingObject(Graphics g)
        {
            _bus.DrawTransport(g);
        }

        public string GetInfo() => _bus?.GetDataForSave();

        public static IDrawingObject Create(string data) => new DrawingObjectBus(data.CreateDrawingBus());
                
    }
}
