﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Bus
{
    internal class DrawingSportBus : DrawingBus
    {
        public void SetDopColor(Color color)
        {
            ((EntitySportBus)Bus).DopColor1 = color;
        }

        public DrawingSportBus(int speed, float weight, Color bodyColor, Color dopColor, bool bodyKit, bool wing, bool sportLine) :
           base(speed, weight, bodyColor)
        {
           Bus = new EntitySportBus(speed, weight, bodyColor, dopColor, bodyKit, wing, sportLine);
        }
        
        public override void DrawTransport(Graphics g)
        {
            if (Bus is not EntitySportBus sportBus)
            {
                return;
            }
            Pen pen = new Pen(Color.Black);
            Brush dopBrush = new SolidBrush(sportBus.DopColor);
            
            if (sportBus.BodyKit)
            {
                Brush br = new SolidBrush(Bus?.BodyColor ?? Color.Black);
                Pen pen1 = new(Color.Black);
                
                g.DrawRectangle(pen1, _startPosX + 20, _startPosY, 150, 50);    
                g.FillRectangle(br, _startPosX + 21, _startPosY+1, 149, 49);
            }

            _startPosX += 10;
            _startPosY += 15;
            base.DrawTransport(g);
            _startPosX -= 10;
            _startPosY -= 15;

            if (sportBus.Sportline)
            {
                Brush brBlue = new SolidBrush(Color.LightBlue);
                g.FillRectangle(dopBrush, _startPosX + 30, _startPosY + 5, 10, 14);
                g.DrawRectangle(pen, _startPosX + 29, _startPosY + 4, 10, 15);

                g.FillRectangle(dopBrush, _startPosX + 60, _startPosY + 5, 10, 14);
                g.DrawRectangle(pen, _startPosX + 59, _startPosY + 4, 10, 15);
            }

            if (sportBus.Wing)
            {
                g.DrawRectangle(pen, _startPosX + 112, _startPosY + 7, 6,50);
                g.DrawRectangle(pen, _startPosX + 112, _startPosY + 17, 6, 40);
                g.DrawRectangle(pen, _startPosX + 112, _startPosY + 27, 6, 10);
                g.DrawRectangle(pen, _startPosX + 112, _startPosY + 37, 6, 10);

            }
        }
    }
}
