﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Bus
{
    internal static class ExtentionBus
    {
        private static readonly char _separatorForObject = ':';

        public static DrawingBus CreateDrawingBus(this string info)
        {
            string[] strs = info.Split(_separatorForObject);
            if (strs.Length == 3)
            {
                return new DrawingBus(Convert.ToInt32(strs[0]),
                    Convert.ToInt32(strs[1]), Color.FromName(strs[2]));
            }
            if (strs.Length == 7)
            {
                return new DrawingSportBus(Convert.ToInt32(strs[0]),
                    Convert.ToInt32(strs[1]), Color.FromName(strs[2]),
                    Color.FromName(strs[3]), Convert.ToBoolean(strs[4]),
                    Convert.ToBoolean(strs[5]), Convert.ToBoolean(strs[6]));
            }
            return null;

        }

        public static string GetDataForSave(this DrawingBus drawingBus)
        {
            var bus = drawingBus.Bus;
            var str = $"{bus.Speed}{_separatorForObject}{bus.Weight}{_separatorForObject}{bus.BodyColor.Name}";
            if (bus is not EntitySportBus sportBus)
            {
                return str;
            }
            return $"{str}{_separatorForObject}{sportBus.DopColor.Name}{_separatorForObject}{sportBus.BodyKit}{_separatorForObject}{sportBus.Wing}{_separatorForObject}{sportBus.Sportline}";
        }
    }
}
